## wasmedge 0.16.1%2Bdfsg

=== lib/host/wasi/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

if(APPLE)
  set(WASMEDGE_WASI_SRCS clock-macos.cpp environ-macos.cpp inode-macos.cpp macos.mm)
elseif(WIN32)
  set(WASMEDGE_WASI_SRCS clock-win.cpp environ-win.cpp inode-win.cpp)
else()
  set(WASMEDGE_WASI_SRCS clock-linux.cpp environ-linux.cpp inode-linux.cpp)
endif()

wasmedge_add_library(wasmedgeHostModuleWasi
  environ.cpp
  vinode.cpp
  wasifunc.cpp
  wasimodule.cpp
  vfs_io.cpp
  ${WASMEDGE_WASI_SRCS}
)

target_include_directories(wasmedgeHostModuleWasi
  PUBLIC
  ${PROJECT_SOURCE_DIR}/thirdparty
)

target_link_libraries(wasmedgeHostModuleWasi
  PUBLIC
  Threads::Threads
  wasmedgeSystem
)

if(NOT APPLE AND NOT WIN32 AND NOT ANDROID)
  target_link_libraries(wasmedgeHostModuleWasi
    PUBLIC
    rt
  )
endif()

if(WIN32)
  target_link_libraries(wasmedgeHostModuleWasi
    PRIVATE
    ktmw32
    ntdll
    wsock32
    ws2_32
    pathcch
    shlwapi
  )
endif()

## wasmedge 0.16.1+dfsg

=== CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

cmake_minimum_required(VERSION 3.18)
cmake_policy(SET CMP0091 NEW)
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()
project(WasmEdge LANGUAGES CXX C)

# CMake build type.
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

# Overwrite it if you want to use static MSVC runtime library.
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")

# WasmEdge CAPI and so versions.
set(WASMEDGE_CAPI_VERSION "0.1.0" CACHE STRING "WasmEdge C API library version")
set(WASMEDGE_CAPI_SOVERSION "0" CACHE STRING "WasmEdge C API library soversion")

# Set cpack package version.
find_program(GIT_CMD git)
# Assuming the git command is not found and .git folder is not available.
set(GIT_VERSION_NOT_FOUND 1)
if(GIT_CMD AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  execute_process(COMMAND
    ${GIT_CMD} describe --match "[0-9].[0-9]*" --tag
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    OUTPUT_VARIABLE CPACK_PACKAGE_VERSION
    RESULT_VARIABLE GIT_VERSION_NOT_FOUND
    OUTPUT_STRIP_TRAILING_WHITESPACE
  )
endif()
if(GIT_VERSION_NOT_FOUND AND NOT GIT_VERSION_NOT_FOUND EQUAL 0)
  set(CPACK_PACKAGE_VERSION "0.0.0-unreleased")
endif()

# Overwrite version information once there is a VERSION file.
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/VERSION")
  file(READ "${CMAKE_CURRENT_SOURCE_DIR}/VERSION" LOCAL_VERSION)
  set(CPACK_PACKAGE_VERSION ${LOCAL_VERSION})
  unset(LOCAL_VERSION)
endif()

# Add the CMake module path.
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# Export compile commands.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Find threads and filesystem.
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Filesystem REQUIRED Final Experimental)
find_package(Threads REQUIRED)

# List of WasmEdge options
option(WASMEDGE_BUILD_TESTS "Generate build targets for the wasmedge unit tests." OFF)
option(WASMEDGE_BUILD_COVERAGE "Generate coverage report. Require WASMEDGE_BUILD_TESTS." OFF)
option(WASMEDGE_BUILD_SHARED_LIB "Generate the WasmEdge shared library." ON)
option(WASMEDGE_BUILD_STATIC_LIB "Generate the WasmEdge static library." OFF)
option(WASMEDGE_BUILD_TOOLS "Generate wasmedge and wasmedgec tools. Depend on and will build the WasmEdge shared library." ON)
option(WASMEDGE_BUILD_FUZZING "Generate fuzzing test tools. Couldn't build with wasmedge tools and unit tests." OFF)
option(WASMEDGE_BUILD_PLUGINS "Generate plugins." ON)
option(WASMEDGE_BUILD_EXAMPLE "Generate examples." OFF)
option(WASMEDGE_BUILD_WASI_NN_RPC "Generate WASI-NN RPC." OFF)
option(WASMEDGE_USE_LLVM "Enable WasmEdge LLVM-based compilation runtime." ON)
if(WASMEDGE_BUILD_AOT_RUNTIME)
  message(WARNING "WASMEDGE_BUILD_AOT_RUNTIME option was renamed to WASMEDGE_USE_LLVM.")
  set(WASMEDGE_USE_LLVM "${WASMEDGE_BUILD_AOT_RUNTIME}" CACHE STRING "Enable WasmEdge LLVM-based compilation runtime.")
  unset(WASMEDGE_BUILD_AOT_RUNTIME CACHE)
endif()
option(WASMEDGE_USE_CXX11_ABI "Enable cxx11 abi when building WasmEdge." ON)
option(WASMEDGE_FORCE_DISABLE_LTO "Forcefully disable link time optimization when linking even in Release/RelWithDeb build." OFF)
option(WASMEDGE_LINK_LLVM_STATIC "Statically link the LLVM library into the WasmEdge tools and libraries." OFF)
option(WASMEDGE_LINK_TOOLS_STATIC "Statically link the wasmedge and wasmedgec tools. Will forcefully link the LLVM library statically." OFF)
option(WASMEDGE_ENABLE_UB_SANITIZER "Enable undefined behavior sanitizer." OFF)
option(WASMEDGE_DISABLE_LIBTINFO "Disable linking against libtinfo when linking LLVM." OFF)

# Options about plug-ins.
#   WASI plug-in: WASI-Crypto proposal.
option(WASMEDGE_PLUGIN_WASI_CRYPTO "Enable and build WasmEdge wasi-crypto plugin." OFF)
#   WASI plug-in: WASI-Http proposal.
option(WASMEDGE_PLUGIN_WASI_HTTP "Enable and build WasmEdge wasi-http plugin." OFF)
#   WASI plug-in: WASI-Logging proposal.
#     Note: WASMEDGE_PLUGIN_WASI_LOGGING is not used until the new plug-in mechanism ready in 0.15.0.
option(WASMEDGE_PLUGIN_WASI_LOGGING "Enable and build WasmEdge wasi-logging plugin." ON)
#   WASI plug-in: WASI-NN proposal with backends.
set(WASMEDGE_PLUGIN_WASI_NN_BACKEND "" CACHE STRING "Enable and build WasmEdge Wasi-NN plugin with backends.")
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_NATIVE "Enable LLAMA_NATIVE(AVX/AVX2/FMA) in the WASI-NN GGML backend." ON)
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_BLAS "Enable LLAMA_BLAS in the WASI-NN GGML backend." OFF)
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_CUBLAS "Enable LLAMA_CUBLAS in the WASI-NN GGML backend." OFF)
option(WASMEDGE_PLUGIN_WASI_NN_GGML_LLAMA_METAL "Enable LLAMA_METAL in the WASI-NN GGML backend. Available on MacOS arm64 only." ON)
option(WASMEDGE_PLUGIN_WASI_NN_WHISPER_METAL "Enable GGML_METAL in the WASI-NN WHISPER backend. Available on MacOS arm64 only." ON)
option(WASMEDGE_PLUGIN_WASI_NN_WHISPER_CUDA "Enable GGML_CUDA in the WASI-NN WHISPER backend." OFF)
option(WASMEDGE_PLUGIN_WASI_NN_BITNET_ARM_TL1 "Enable BitNet.cpp ARM_TL1 optimization" OFF)
option(WASMEDGE_PLUGIN_WASI_NN_BITNET_X86_TL2 "Enable BitNet.cpp X86_TL2 optimization" OFF)
#   WASI plug-in: WASI-Poll proposal.
option(WASMEDGE_PLUGIN_WASI_POLL "Enable and build WasmEdge wasi-poll plugin." OFF)
#   WasmEdge plug-in: wasm-bpf.
option(WASMEDGE_PLUGIN_WASM_BPF "Enable and build WasmEdge wasm-bpf plugin." OFF)
#   WasmEdge plug-in: ffmpeg.
option(WASMEDGE_PLUGIN_FFMPEG "Enable and build WasmEdge ffmpeg plugin." OFF)
#   WasmEdge plug-in: Image.
option(WASMEDGE_PLUGIN_IMAGE "Enable and build WasmEdge image plugin." OFF)
#   WasmEdge plug-in: LLMC.
option(WASMEDGE_PLUGIN_LLMC "Enable and build WasmEdge LLMC plugin." OFF)
#   WasmEdge plug-in: OCR.
option(WASMEDGE_PLUGIN_OCR "Enable and build WasmEdge OCR plugin." OFF)
#   WasmEdge plug-in: OpenCV-mini.
option(WASMEDGE_PLUGIN_OPENCVMINI "Enable and build WasmEdge opencvmini plugin." OFF)
#   WasmEdge plug-in: Process.
option(WASMEDGE_PLUGIN_PROCESS "Enable and build WasmEdge process plugin." OFF)
#   WasmEdge plug-in: Stable-diffusion.
option(WASMEDGE_PLUGIN_STABLEDIFFUSION "Enable and build WasmEdge stable-diffusion plugin." OFF)
option(WASMEDGE_PLUGIN_STABLEDIFFUSION_CUDA "Enable CUDA in the stable-diffusion plugin." OFF)
option(WASMEDGE_PLUGIN_STABLEDIFFUSION_METAL "Enable Metal in the stable-diffusion plugin." ON)
option(WASMEDGE_PLUGIN_STABLEDIFFUSION_OPENMP "Enable OpenMP in the stable-diffusion plugin." OFF)
#   WasmEdge plug-in: TensorFlow.
option(WASMEDGE_PLUGIN_TENSORFLOW "Enable and build WasmEdge TensorFlow plugin." OFF)
#   WasmEdge plug-in: TensorFlow-Lite.
option(WASMEDGE_PLUGIN_TENSORFLOWLITE "Enable and build WasmEdge TensorFlow-Lite plugin." OFF)
#   WasmEdge plug-in: zlib.
option(WASMEDGE_PLUGIN_ZLIB "Enable and build WasmEdge zlib plugin." OFF)
#   WasmEdge plug-in dependencies.
option(WASMEDGE_FORCE_DOWNLOAD_SIMDJSON "Force download and build simdjson for the wasi-nn plugin." OFF)
# Fuzzing and tools and tests are exclusive.
if(WASMEDGE_BUILD_TOOLS AND WASMEDGE_BUILD_FUZZING)
  message(FATAL_ERROR "wasmedge tool and fuzzing tool are exclusive options.")
endif()
if(WASMEDGE_BUILD_TESTS AND WASMEDGE_BUILD_FUZZING)
  message(FATAL_ERROR "unit tests and fuzzing tool are exclusive options.")
endif()

# Static library will forcefully turn off the LTO.
if(WASMEDGE_BUILD_STATIC_LIB)
  set(WASMEDGE_FORCE_DISABLE_LTO ON)
endif()

# WasmEdge tool options.
if(WASMEDGE_BUILD_TOOLS)
  if(WASMEDGE_LINK_TOOLS_STATIC)
    # Static tools will link LLVM statically.
    set(WASMEDGE_LINK_LLVM_STATIC ON)
    # Tools will forcefully turn on the static library building.
    set(WASMEDGE_BUILD_STATIC_LIB ON)
    if(WASMEDGE_BUILD_PLUGINS)
      message(WARNING "For tuning on the WASMEDGE_LINK_TOOLS_STATIC option, the plugins will not work.")
    endif()
  else()
    # Tools will forcefully turn on the shared library building.
    set(WASMEDGE_BUILD_SHARED_LIB ON)
  endif()
endif()

if(WASMEDGE_BUILD_WASI_NN_RPC)
  # * Homebrew: grpc
  # * Debian, Ubuntu: libgrpc-dev, libgrpc++-dev
  find_package(PkgConfig)
  if(PkgConfig_FOUND)
    pkg_check_modules(gRPCPP grpc++)
  endif()
  # Do not check find_package(gRPC), because libgrpc-dev for Ubuntu 22.04 does not contain cmake files.
  # https://packages.ubuntu.com/search?keywords=libgrpc-dev
  # Do not check find_package(protobuf), because libprotobuf-dev for Ubuntu does not contain cmake files.
  # https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1027876
  if(gRPCPP_FOUND AND WASMEDGE_BUILD_SHARED_LIB)
    message(STATUS "If you see an error related to gRPC or protobuf, try setting WASMEDGE_BUILD_WASI_NN_RPC to OFF.")
  endif()
  if(WASMEDGE_BUILD_WASI_NN_RPC AND NOT WASMEDGE_BUILD_SHARED_LIB)
    message(FATAL_ERROR "WASMEDGE_BUILD_WASI_NN_RPC depends on WASMEDGE_BUILD_SHARED_LIB.")
  endif()
endif()

set(WASMEDGE_BUILD_PACKAGE "DEB;RPM" CACHE STRING "Package generate types")
set(CPACK_PROJECT_CONFIG_FILE ${CMAKE_CURRENT_SOURCE_DIR}/cmake/cpack_config.cmake)

if(WASMEDGE_BUILD_COVERAGE)
  set(GCOVR_ADDITIONAL_ARGS "--exclude-unreachable-branches;--exclude-throw-branches")
  include(CodeCoverage)
  append_coverage_compiler_flags()
endif()

include(FetchContent)
include(Helper)
include(GNUInstallDirs)

set(CPACK_PACKAGE_VENDOR Second State LLC)
set(CPACK_PACKAGE_FILE_NAME "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION}-${CMAKE_SYSTEM_NAME}")
set(CPACK_STRIP_FILES ON)
set(CPACK_PACKAGE_CONTACT "Shen-Ta Hsieh <beststeve@secondstate.io>")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "High performance WebAssembly Virtual Machine")
set(CPACK_ARCHIVE_COMPONENT_INSTALL ON)
set(CPACK_ARCHIVE_WASMEDGE_FILE_NAME "${CPACK_PACKAGE_FILE_NAME}")
set(CPACK_RPM_COMPONENT_INSTALL ON)
set(CPACK_RPM_MAIN_COMPONENT "WasmEdge")
set(CPACK_RPM_PACKAGE_LICENSE "Apache 2.0")
set(CPACK_DEB_COMPONENT_INSTALL ON)
set(CPACK_DEBIAN_WASMEDGE_PACKAGE_NAME wasmedge)
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_COMPRESSION_TYPE xz)
set(CPACK_DEBIAN_PACKAGE_HOMEPAGE "https://github.com/WasmEdge/WasmEdge/")
set(CPACK_DEBIAN_PACKAGE_SHLIBDEPS ON)
set(CPACK_DEBIAN_PACKAGE_CONTROL_STRICT_PERMISSION ON)
set(CPACK_GENERATOR "${WASMEDGE_BUILD_PACKAGE}")
set(CPACK_PACKAGE_DESCRIPTION "WasmEdge is a high performance, extensible, and hardware optimized WebAssembly Virtual Machine for cloud, AI, and blockchain applications.")
if("${CMAKE_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_SOURCE_DIR}")
  # If WasmEdge is the top project, only pack the WasmEdge component.
  set(CPACK_COMPONENTS_ALL "WasmEdge")
endif()

add_subdirectory(include)
add_subdirectory(lib)
if(WASMEDGE_BUILD_PLUGINS AND (WASMEDGE_BUILD_STATIC_LIB OR WASMEDGE_BUILD_SHARED_LIB))
  # Plug-ins should depend on the WasmEdge library.
  if(WASMEDGE_BUILD_STATIC_LIB AND NOT WASMEDGE_BUILD_SHARED_LIB)
    # Link to the static library if only the WasmEdge static library is built.
    # If the WasmEdge shared library is built, the plug-ins will link to the shared library.
    set(WASMEDGE_LINK_PLUGINS_STATIC ON)
  endif()
  add_subdirectory(plugins)
endif()
add_subdirectory(thirdparty)
if(WASMEDGE_BUILD_TOOLS OR WASMEDGE_BUILD_FUZZING)
  add_subdirectory(tools)
endif()
if(WASMEDGE_BUILD_TESTS)
  include(CTest)
  add_subdirectory(test)
endif()
if(WASMEDGE_BUILD_EXAMPLE)
  add_subdirectory(examples/plugin/get-string)
endif()

include(CPack)
include(CPackComponent)

=== include/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

string(REGEX MATCH "^([0-9]+)[.]([0-9]+)[.]([0-9]+)*"
    WASMEDGE_VERSION_STRING
    "${CPACK_PACKAGE_VERSION}"
)
string(REPLACE "." ";" WASMEDGE_VERSION_LIST ${WASMEDGE_VERSION_STRING})
list(GET WASMEDGE_VERSION_LIST 0 WASMEDGE_VERSION_MAJOR)
list(GET WASMEDGE_VERSION_LIST 1 WASMEDGE_VERSION_MINOR)
list(GET WASMEDGE_VERSION_LIST 2 WASMEDGE_VERSION_PATCH)
set(WASMEDGE_API_VERSION "4")

# Check the MMAP and PWD exists.
include(CheckCXXSymbolExists)
check_cxx_symbol_exists(mmap sys/mman.h HAVE_MMAP)
include(CheckIncludeFileCXX)
CHECK_INCLUDE_FILE_CXX(pwd.h HAVE_PWD_H)

configure_file(api/wasmedge/int128.h api/wasmedge/int128.h COPYONLY)
configure_file(api/wasmedge/version.h.in api/wasmedge/version.h)
configure_file(api/wasmedge/wasmedge.h api/wasmedge/wasmedge.h COPYONLY)
configure_file(api/wasmedge/wasmedge_ast.h api/wasmedge/wasmedge_ast.h COPYONLY)
configure_file(api/wasmedge/wasmedge_basic.h api/wasmedge/wasmedge_basic.h COPYONLY)
configure_file(api/wasmedge/wasmedge_compiler.h api/wasmedge/wasmedge_compiler.h COPYONLY)
configure_file(api/wasmedge/wasmedge_configure.h api/wasmedge/wasmedge_configure.h COPYONLY)
configure_file(api/wasmedge/wasmedge_context.h api/wasmedge/wasmedge_context.h COPYONLY)
configure_file(api/wasmedge/wasmedge_deprecated.h api/wasmedge/wasmedge_deprecated.h COPYONLY)
configure_file(api/wasmedge/wasmedge_execution.h api/wasmedge/wasmedge_execution.h COPYONLY)
configure_file(api/wasmedge/wasmedge_experimental.h api/wasmedge/wasmedge_experimental.h COPYONLY)
configure_file(api/wasmedge/wasmedge_instance.h api/wasmedge/wasmedge_instance.h COPYONLY)
configure_file(api/wasmedge/wasmedge_plugin.h api/wasmedge/wasmedge_plugin.h COPYONLY)
configure_file(api/wasmedge/wasmedge_tools.h api/wasmedge/wasmedge_tools.h COPYONLY)
configure_file(api/wasmedge/wasmedge_value.h api/wasmedge/wasmedge_value.h COPYONLY)
configure_file(api/wasmedge/wasmedge_vm.h api/wasmedge/wasmedge_vm.h COPYONLY)
configure_file(common/config.h.in common/config.h)
configure_file(common/enum.inc api/wasmedge/enum.inc COPYONLY)
configure_file(common/enum_configure.h api/wasmedge/enum_configure.h COPYONLY)
configure_file(common/enum_errcode.h api/wasmedge/enum_errcode.h COPYONLY)
configure_file(common/enum_types.h api/wasmedge/enum_types.h COPYONLY)
configure_file(common/version.h.in common/version.h)
unset(WASMEDGE_VERSION_STRING)
unset(WASMEDGE_VERSION_LIST)
unset(WASMEDGE_VERSION_MAJOR)
unset(WASMEDGE_VERSION_MINOR)
unset(WASMEDGE_VERSION_PATCH)
unset(WASMEDGE_API_VERSION)

=== plugins/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

# WASI plug-in: WASI-Crypto proposal.
if(WASMEDGE_PLUGIN_WASI_CRYPTO)
  add_subdirectory(wasi_crypto)
endif()

# WASI plug-in: WASI-Http proposal.
if(WASMEDGE_PLUGIN_WASI_HTTP)
  add_subdirectory(wasi_http)
endif()

# WASI plug-in: WASI-Logging proposal.
if(WASMEDGE_PLUGIN_WASI_LOGGING)
  # BUILTIN-PLUGIN: Add the wasi-logging plugin here after the new plugin
  # architecture ready in 0.15.0.
endif()

# WASI plug-in: WASI-NN proposal with backends.
if(WASMEDGE_PLUGIN_WASI_NN_BACKEND)
  add_subdirectory(wasi_nn)
endif()

# WASI plug-in: WASI-Poll proposal.
if(WASMEDGE_PLUGIN_WASI_POLL)
  add_subdirectory(wasi_poll)
endif()

# WasmEdge plug-in: wasm-bpf.
if(WASMEDGE_PLUGIN_WASM_BPF)
  # Only Linux systems support wasm_bpf now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasm_bpf)
  else()
    message(WARNING "Only Linux platforms support wasm_bpf plug-in now.")
  endif()
endif()

# WasmEdge plug-in: ffmpeg.
if(WASMEDGE_PLUGIN_FFMPEG)
  add_subdirectory(wasmedge_ffmpeg)
endif()

# WasmEdge plug-in: Image.
if(WASMEDGE_PLUGIN_IMAGE)
  # Only Linux and MacOS support wasmedge_image now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_image)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_Image plug-in now.")
  endif()
endif()

# WasmEdge plug-in: LLMC.
if(WASMEDGE_PLUGIN_LLMC)
  add_subdirectory(wasmedge_llmc)
endif()

# WasmEdge plug-in: OCR.
if(WASMEDGE_PLUGIN_OCR)
  add_subdirectory(wasmedge_ocr)
endif()

# WasmEdge plug-in: OpenCV-mini.
if(WASMEDGE_PLUGIN_OPENCVMINI)
  # Only Linux and MacOS support wasmedge_opencvmini now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_opencvmini)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_OpenCVMini plug-in now.")
  endif()
endif()

# WasmEdge plug-in: Process.
if(WASMEDGE_PLUGIN_PROCESS)
  # Only Linux systems support wasmedge_process now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    add_subdirectory(wasmedge_process)
  else()
    message(WARNING "Only Linux platforms support WasmEdge_Process plug-in now.")
  endif()
endif()

# WasmEdge plug-in: Stable-diffusion.
if(WASMEDGE_PLUGIN_STABLEDIFFUSION)
  # Only Linux and MacOS support wasmedge_stablediffusion now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_stablediffusion)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_StableDiffusion plug-in now.")
  endif()
endif()

# WasmEdge plug-in: TensorFlow.
if(WASMEDGE_PLUGIN_TENSORFLOW)
  # Only Linux and MacOS support wasmedge_tensorflow now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflow)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_Tensorflow plug-in now.")
  endif()
endif()

# WasmEdge plug-in: TensorFlow-Lite.
if(WASMEDGE_PLUGIN_TENSORFLOWLITE)
  # Only Linux and MacOS support wasmedge_tensorflowlite now.
  if(CMAKE_SYSTEM_NAME MATCHES "Linux|Darwin")
    add_subdirectory(wasmedge_tensorflowlite)
  else()
    message(WARNING "Only Linux and Darwin platforms support WasmEdge_TensorflowLite plug-in now.")
  endif()
endif()

# WasmEdge plug-in: zlib.
if(WASMEDGE_PLUGIN_ZLIB)
  add_subdirectory(wasmedge_zlib)
endif()

=== test/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

find_package(GTest QUIET)
if(GTest_FOUND)
  set(GTEST_BOTH_LIBRARIES "${GTEST_BOTH_LIBRARIES};Threads::Threads")
else()
  FetchContent_Declare(
    GTest
    GIT_REPOSITORY https://github.com/google/googletest.git
    GIT_TAG v1.15.2
    GIT_SHALLOW TRUE
  )
  set(BUILD_GMOCK OFF CACHE BOOL "Builds the googlemock subproject" FORCE)
  set(INSTALL_GTEST OFF CACHE BOOL "Enable installation of googletest. (Projects embedding googletest may want to turn this OFF.)" FORCE)
  if(CMAKE_CXX_COMPILER_ID MATCHES "MSVC")
    add_compile_options(
      ${WASMEDGE_CFLAGS}
    )
  else()
    add_compile_options(
      ${WASMEDGE_CFLAGS}
      -Wno-language-extension-token
      -Wno-missing-noreturn
      -Wno-shift-sign-overflow
      -Wno-undef
      -Wno-unused-member-function
      $<$<COMPILE_LANGUAGE:CXX>:-Wno-zero-as-null-pointer-constant>
      -Wno-deprecated
    )
    if(WIN32)
      add_compile_options(
        -Wno-padded
        -Wno-character-conversion
        -Wno-unique-object-duplication
        -Wno-nrvo
      )
    endif()
    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
      add_compile_options(
        -Wno-suggest-destructor-override
        $<$<COMPILE_LANGUAGE:CXX>:-Wno-suggest-override>
      )
    endif()
  endif()

  FetchContent_MakeAvailable(GTest)
  set(GTEST_BOTH_LIBRARIES "gtest_main")
endif()

if(WASMEDGE_USE_LLVM)
  add_subdirectory(aot)
  add_subdirectory(llvm)
  add_subdirectory(mixcall)
endif()
add_subdirectory(common)
add_subdirectory(spec)
add_subdirectory(loader)
add_subdirectory(executor)
add_subdirectory(validator)
add_subdirectory(component)
add_subdirectory(thread)
if(WASMEDGE_BUILD_SHARED_LIB)
  add_subdirectory(api)
  add_subdirectory(externref)
endif()
if(WASMEDGE_BUILD_PLUGINS)
  add_subdirectory(plugins)
endif()
add_subdirectory(host/socket)
add_subdirectory(host/wasi)
add_subdirectory(host/mock)
add_subdirectory(expected)
add_subdirectory(span)
add_subdirectory(po)
add_subdirectory(memlimit)
add_subdirectory(errinfo)

if(WASMEDGE_BUILD_COVERAGE)
  setup_target_for_coverage_gcovr_html(
    NAME coverage
    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
    DEPENDENCIES wasmedge
    BASE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
    EXCLUDE
    "${PROJECT_SOURCE_DIR}/thirdparty/*"
    "${PROJECT_SOURCE_DIR}/test/*"
  )
  setup_target_for_coverage_gcovr_xml(
    NAME codecov
    EXECUTABLE ctest -j ${PROCESSOR_COUNT}
    DEPENDENCIES wasmedge
    EXCLUDE
    "${PROJECT_SOURCE_DIR}/thirdparty/*"
    "${PROJECT_SOURCE_DIR}/test/*"
  )
endif()

=== examples/embed_cxx/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.18)

project(embed_cxx CXX)

set(CMAKE_CXX_STANDARD 17)

set(WASMEDGE_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../..)
set(WASMEDGE_USE_LLVM OFF)
if (CMAKE_GENERATOR STREQUAL Ninja)
  set(CMAKE_JOB_POOLS "link=2")
  set(CMAKE_JOB_POOL_LINK link)
endif()
add_subdirectory(${WASMEDGE_SOURCE_DIR} WasmEdge)
include_directories(${WasmEdge_BINARY_DIR}/include/api)

add_subdirectory(script)

add_executable(
    embed_cxx
    main.cpp
)

target_link_libraries(
    embed_cxx
    wasmedge_shared
    fibonacci
)

get_filename_component(WASI_SDK_HOME $ENV{WASI_SDK_HOME} ABSOLUTE)
message("WASI_SDK_HOME=${WASI_SDK_HOME}")
# download wasi-sdk
if (NOT EXISTS ${WASI_SDK_HOME})
    set(WASI_SDK_VERSION 14.0)
    set(WASI_SDK_PATH ${CMAKE_CURRENT_BINARY_DIR}/deps/wasi-sdk)
    set(WASI_SDK_HOME ${WASI_SDK_PATH}/wasi-sdk-${WASI_SDK_VERSION})

    if(NOT EXISTS "${WASI_SDK_HOME}/bin/clang")
        message("download wasi-sdk")
        if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
            set(WASI_SDK_TARGET "darwin")
        elseif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
            set(WASI_SDK_TARGET "linux")
        elseif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
            set(WASI_SDK_TARGET "mingw")
        endif ()

        set(WASI_SDK_TARGZ_URL https://github.com/WebAssembly/wasi-sdk/releases/download/wasi-sdk-14/wasi-sdk-${WASI_SDK_VERSION}-${WASI_SDK_TARGET}.tar.gz)
        set(WASI_SDK_TARGZ_PATH ${CMAKE_CURRENT_BINARY_DIR}/wasi-sdk.tar.gz)
        file(DOWNLOAD ${WASI_SDK_TARGZ_URL} ${WASI_SDK_TARGZ_PATH} INACTIVITY_TIMEOUT 10)
        file(ARCHIVE_EXTRACT INPUT ${WASI_SDK_TARGZ_PATH} DESTINATION ${WASI_SDK_PATH})
    endif()
endif()

include(ExternalProject)
ExternalProject_Add(
        script_wasm
        SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/script
        BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/script_wasm
        CMAKE_CACHE_ARGS
        -DWASI_SDK_PREFIX:FILEPATH=${WASI_SDK_HOME}
        -DCMAKE_TOOLCHAIN_FILE:FILEPATH=${WASI_SDK_HOME}/share/cmake/wasi-sdk.cmake
        -DCMAKE_SYSROOT:FILEPATH=${WASI_SDK_HOME}/share/wasi-sysroot
        -DWASM_OUT_DIR:FILEPATH=${CMAKE_CURRENT_BINARY_DIR}
        INSTALL_COMMAND ""
        BUILD_ALWAYS 1
)

add_dependencies(
    embed_cxx
    script_wasm
)

=== lib/executor/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgeExecutor
  instantiate/import.cpp
  instantiate/function.cpp
  instantiate/global.cpp
  instantiate/table.cpp
  instantiate/memory.cpp
  instantiate/elem.cpp
  instantiate/data.cpp
  instantiate/export.cpp
  instantiate/tag.cpp
  instantiate/module.cpp
  instantiate/component/component.cpp
  instantiate/component/component_alias.cpp
  instantiate/component/component_canon.cpp
  instantiate/component/component_export.cpp
  instantiate/component/component_import.cpp
  instantiate/component/component_instance.cpp
  instantiate/component/component_module.cpp
  instantiate/component/component_start.cpp
  instantiate/component/component_type.cpp
  engine/proxy.cpp
  engine/controlInstr.cpp
  engine/tableInstr.cpp
  engine/threadInstr.cpp
  engine/memoryInstr.cpp
  engine/variableInstr.cpp
  engine/refInstr.cpp
  engine/engine.cpp
  helper.cpp
  executor.cpp
  coredump.cpp
)

target_link_libraries(wasmedgeExecutor
  PUBLIC
  wasmedgeCommon
  wasmedgeSystem
)

=== lib/llvm/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

find_package(LLVM REQUIRED HINTS "${LLVM_CMAKE_PATH}" "${LLVM_DIR}")
list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_DIR}")
include(LLVMConfig)
include(AddLLVM)

find_package(LLD HINTS "${LLD_CMAKE_PATH}" "${LLD_DIR}" "${LLVM_LIBRARY_DIR}/cmake/lld")
if(LLD_FOUND)
  list(APPEND CMAKE_MODULE_PATH "${LLD_CMAKE_DIR}")
endif()

if(WASMEDGE_LINK_LLVM_STATIC)
  wasmedge_add_library(wasmedgeLLVM
    compiler.cpp
    codegen.cpp
    data.cpp
    jit.cpp
  )

  target_link_libraries(wasmedgeLLVM
    PUBLIC
    wasmedgeCommon
    wasmedgeSystem
    std::filesystem
    ${WASMEDGE_LLVM_LINK_STATIC_COMPONENTS}
    ${WASMEDGE_LLVM_LINK_SHARED_COMPONENTS}
  )
else()
  if(APPLE)
    list(APPEND LLD_LIBS lldMachO)
  elseif(WIN32)
    list(APPEND LLD_LIBS lldCOFF)
    set(EXTRA_COMPONENTS DebugInfoPDB LibDriver WindowsManifest)
  else()
    list(APPEND LLD_LIBS lldELF)
  endif()

  list(APPEND LLD_LIBS lldCommon)
  if(LLVM_VERSION_MAJOR LESS_EQUAL 13)
    list(APPEND LLD_LIBS lldDriver)
  endif()

  # Command line warning D9025 : overriding '/EHs' with '/EHs-'
  # prevent LLVM from adding /EHs-c-.
  if(WIN32)
    set(LLVM_REQUIRES_EH ON)
  endif()

  llvm_add_library(wasmedgeLLVM
    compiler.cpp
    codegen.cpp
    data.cpp
    jit.cpp
    LINK_LIBS
    wasmedgeCommon
    wasmedgeSystem
    ${LLD_LIBS}
    std::filesystem
    ${CMAKE_THREAD_LIBS_INIT}
    LINK_COMPONENTS
    core
    lto
    native
    nativecodegen
    option
    passes
    support
    orcjit
    transformutils
    ${EXTRA_COMPONENTS}
  )
endif()

wasmedge_setup_target(wasmedgeLLVM)

target_include_directories(wasmedgeLLVM
  SYSTEM
  PRIVATE
  ${LLVM_INCLUDE_DIR}
  ${LLD_INCLUDE_DIRS}
)

target_include_directories(wasmedgeLLVM
  PUBLIC
  ${PROJECT_BINARY_DIR}/include
)

include(CheckCXXSourceCompiles)
set(CMAKE_REQUIRED_LINK_OPTIONS "-Wl,-lc,--exclude-libs=libc.a")
check_cxx_source_compiles("int main(){}" SUPPORT_EXCLUDE_LIBS)

if(SUPPORT_EXCLUDE_LIBS)
  file(GLOB LLD_ALL_LIBS ${LLVM_LIBRARY_DIR}/liblld*.a)
  list(TRANSFORM LLD_ALL_LIBS REPLACE "^.*/" "")
  string(JOIN : LLD_ALL_LIBS_COLON ${LLD_ALL_LIBS})
  if(NOT LLD_ALL_LIBS_COLON STREQUAL "")
    target_link_options(wasmedgeLLVM
      PUBLIC
      "SHELL:-Wl,--exclude-libs=${LLD_ALL_LIBS_COLON}"
    )
  endif()
endif()

=== lib/loader/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgeLoaderFileMgr
  filemgr.cpp
  shared_library.cpp
  aot_section.cpp
)

target_link_libraries(wasmedgeLoaderFileMgr
  PUBLIC
  wasmedgeCommon
  wasmedgeSystem
  std::filesystem
)

if(NOT WIN32)
  target_link_libraries(wasmedgeLoaderFileMgr
    PUBLIC
    dl
  )
endif()

wasmedge_add_library(wasmedgeLoader
  ast/component/component.cpp
  ast/component/component_section.cpp
  ast/component/component_instance.cpp
  ast/component/component_sort.cpp
  ast/component/component_alias.cpp
  ast/component/component_canonical.cpp
  ast/component/component_start.cpp
  ast/component/component_type.cpp
  ast/component/component_import.cpp
  ast/component/component_export.cpp
  ast/component/component_declarator.cpp
  ast/component/component_descriptor.cpp
  ast/component/component_valtype.cpp
  ast/module.cpp
  ast/section.cpp
  ast/description.cpp
  ast/segment.cpp
  ast/type.cpp
  ast/expression.cpp
  ast/instruction.cpp
  serialize/serial_description.cpp
  serialize/serial_expression.cpp
  serialize/serial_instruction.cpp
  serialize/serial_module.cpp
  serialize/serial_section.cpp
  serialize/serial_segment.cpp
  serialize/serial_type.cpp
  loader.cpp
)

target_link_libraries(wasmedgeLoader
  PUBLIC
  wasmedgeCommon
  wasmedgeLoaderFileMgr
  std::filesystem
)

=== lib/system/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgeSystem
  allocator.cpp
  fault.cpp
  mmap.cpp
  path.cpp
  stacktrace.cpp
)

target_include_directories(wasmedgeSystem
  PUBLIC
  ${CMAKE_CURRENT_BINARY_DIR}
)

target_link_libraries(wasmedgeSystem
  PUBLIC
  wasmedgeCommon
)

if(WIN32)
  target_link_libraries(wasmedgeSystem
    PRIVATE
    dbghelp
  )
endif()

=== lib/validator/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

wasmedge_add_library(wasmedgeValidator
  formchecker.cpp
  validator.cpp
  component_validator.cpp
)

target_link_libraries(wasmedgeValidator
  PUBLIC
  wasmedgeCommon
)

=== lib/wasi_nn_rpc/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

find_package(PkgConfig REQUIRED)
pkg_check_modules(PROTOBUF protobuf REQUIRED)
pkg_check_modules(GRPC grpc REQUIRED)
pkg_check_modules(GRPCPP grpc++ REQUIRED)

# gRPC::grpc_cpp_plugin can't be used because libgrpc-dev for Ubuntu 22.04 does not contain cmake files.
# https://packages.ubuntu.com/search?keywords=libgrpc-dev
find_program(GRPC_CPP_PLUGIN grpc_cpp_plugin REQUIRED)

# protobuf_generate() can't be used on Debian, Ubuntu, etc., as libprotobuf-dev does not contain cmake files:
# https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1027876
# The situation is similar for other distros too.
# As a workaround, we execute the protoc command directly.
execute_process(
  COMMAND protoc --proto_path=${CMAKE_CURRENT_SOURCE_DIR} --cpp_out=${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/wasi_ephemeral_nn.proto
  COMMAND protoc --proto_path=${CMAKE_CURRENT_SOURCE_DIR} --grpc_out=${CMAKE_CURRENT_BINARY_DIR} --plugin=protoc-gen-grpc=${GRPC_CPP_PLUGIN} ${CMAKE_CURRENT_SOURCE_DIR}/wasi_ephemeral_nn.proto
)

# wasiNNRPC has to be a separate shared library to avoid
# `[libprotobuf ERROR google/protobuf/descriptor_database.cc:120] File already exists in database: wasi_ephemeral_nn.proto`,
# because both wasi_nn_rpcserver and libwasmedgePluginWasiNN.so depend on it.
# https://github.com/protocolbuffers/protobuf/issues/1941#issuecomment-284582895
if(NOT WASMEDGE_BUILD_SHARED_LIB)
  message(FATAL_ERROR "WASMEDGE_BUILD_WASI_NN_RPC depends on WASMEDGE_BUILD_SHARED_LIB")
endif()
wasmedge_add_library(wasiNNRPC SHARED
  wasi_ephemeral_nn.grpc.pb.cc
  wasi_ephemeral_nn.grpc.pb.h
  wasi_ephemeral_nn.pb.cc
  wasi_ephemeral_nn.pb.h
)

set(WASMEDGE_WASI_NN_RPC_VERSION "0.1.0" CACHE STRING "WasmEdge WASI-NN RPC version")
set(WASMEDGE_WASI_NN_RPC_SOVERSION "0" CACHE STRING "WasmEdge WASI-NN RPC soversion")

set_target_properties(wasiNNRPC PROPERTIES
  CXX_VISIBILITY_PRESET default
  VERSION "${WASMEDGE_WASI_NN_RPC_VERSION}"
  SOVERSION "${WASMEDGE_WASI_NN_RPC_SOVERSION}"
)
install(TARGETS wasiNNRPC
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE COMPONENT WasmEdge
)

target_include_directories(wasiNNRPC PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_compile_options(wasiNNRPC PUBLIC ${PROTOBUF_CFLAGS})
target_compile_options(wasiNNRPC PUBLIC ${GRPCPP_CFLAGS})
target_link_libraries(wasiNNRPC PUBLIC ${PROTOBUF_LDFLAGS})
target_link_libraries(wasiNNRPC PUBLIC ${GRPCPP_LDFLAGS})
# grpc++_reflection helps debugging the server with grpcurl
# target_link_libraries(wasiNNRPC PUBLIC grpc++_reflection)

=== plugins/wasi_crypto/CMakeLists.txt ===
# SPDX-License-Identifier: Apache-2.0
# SPDX-FileCopyrightText: 2019-2024 Second State INC

set(OPENSSL_USE_STATIC_LIBS ON)
find_package(OpenSSL REQUIRED)

wasmedge_add_library(wasmedgePluginWasiCrypto
  SHARED
  ctx.cpp
  asymmetric_common/ctx.cpp
  asymmetric_common/func.cpp
  asymmetric_common/keypair.cpp
  asymmetric_common/module.cpp
  asymmetric_common/publickey.cpp
  asymmetric_common/secretkey.cpp
  common/array_output.cpp
  common/ctx.cpp
  common/func.cpp
  common/module.cpp
  common/options.cpp
  kx/ctx.cpp
  kx/dh/ecdsa.cpp
  kx/dh/x25519.cpp
  kx/func.cpp
  kx/kx.cpp
  kx/module.cpp
  kx/options.cpp
  signatures/ctx.cpp
  signatures/ecdsa.cpp
  signatures/eddsa.cpp
  signatures/func.cpp
  signatures/module.cpp
  signatures/options.cpp
  signatures/rsa.cpp
  signatures/signatures.cpp
  signatures/signstate.cpp
  signatures/verificationstate.cpp
  symmetric/aeads.cpp
  symmetric/ctx.cpp
  symmetric/func.cpp
  symmetric/hash.cpp
  symmetric/kdf.cpp
  symmetric/key.cpp
  symmetric/mac.cpp
  symmetric/module.cpp
  symmetric/options.cpp
  symmetric/state.cpp
  symmetric/tag.cpp
  utils/evp_wrapper.cpp
  utils/hostfunction.cpp
)

target_compile_options(wasmedgePluginWasiCrypto
  PUBLIC
  -DWASMEDGE_PLUGIN
  -DOPENSSL_API_COMPAT=0x10100000L
)

target_include_directories(wasmedgePluginWasiCrypto
  PUBLIC
  $<TARGET_PROPERTY:wasmedgePlugin,INCLUDE_DIRECTORIES>
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${PROJECT_SOURCE_DIR}/thirdparty
)

target_link_libraries(wasmedgePluginWasiCrypto
  PUBLIC
  OpenSSL::Crypto
)
if(WASMEDGE_LINK_PLUGINS_STATIC)
  target_link_libraries(wasmedgePluginWasiCrypto
    PRIVATE
    wasmedgeCAPI
  )
else()
  target_link_libraries(wasmedgePluginWasiCrypto
    PRIVATE
    wasmedge_shared
  )
endif()

install(
  TARGETS wasmedgePluginWasiCrypto
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/wasmedge
  COMPONENT WasmEdge
)

=== debian/changelog ===
wasmedge (0.16.1+dfsg-1) unstable; urgency=medium

  * New upstream release.
    - Remove examples/capi/mandelbrot patch, fixed upstream.

 -- Faidon Liambotis <paravoid@debian.org>  Tue, 06 Jan 2026 11:38:30 +0200

=== debian/control ===
Source: wasmedge
Section: web
Maintainer: Faidon Liambotis <paravoid@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libspdlog-dev,
 llvm-dev,
 liblld-dev,
 lowdown,
Standards-Version: 4.7.3
Homepage: https://wasmedge.org/
Vcs-Browser: https://salsa.debian.org/debian/wasmedge
Vcs-Git: https://salsa.debian.org/debian/wasmedge.git

Package: wasmedge
Architecture: amd64 arm64
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libwasmedge0 (= ${binary:Version}),
Description: standalone runtime for WebAssembly
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the general WASM runtime ("wasmedge run") as well as the
 ahead-of-time WASM compiler ("wasmedge compile").

Package: libwasmedge0
Section: libs
Architecture: amd64 arm64
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: standalone runtime for WebAssembly (C API shared library)
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the C API shared library.

Package: libwasmedge-dev
Section: libdevel
Architecture: amd64 arm64
Multi-Arch: same
Depends:
 ${misc:Depends},
 libwasmedge0 (= ${binary:Version}),
Description: standalone runtime for WebAssembly (development headers)
 WasmEdge is a lightweight, high-performance, and extensible WebAssembly
 runtime for cloud native, edge, and decentralized applications.
 .
 It powers serverless apps, embedded functions, microservices, smart contracts,
 and IoT devices.
 .
 This package provides the C API shared library development headers.

=== debian/tests/control ===
# This test suite uses the "bats" bash automated testing system, to enhance
# readability and avoid hand-coding e.g. multi-line partial output assertions.
#
# bats is a thin layer on top of bash and thus the learning curve for drive-by
# contributions is hopefully not too steep for an average Debian contributor.
#
# Please use shellcheck and shfmt (both supporting bats natively) when
# modifying any files in this test suite.

Tests: basic
Depends:
  bats, bats-support, bats-assert,
  wasmedge,
  wabt,

Tests: capi-mandelbrot
Depends:
  bats, bats-support, bats-assert,
  libwasmedge-dev,
  wasmedge,
  build-essential,
  clang,
  lld,
  libclang-rt-dev-wasm32,
  wasi-libc,
  wabt,

Tests: capi-parse-json
Depends:
  bats, bats-support, bats-assert,
  libwasmedge-dev,
  build-essential,
  libjson-c-dev,
  wabt,

Tests: capi-wasi-env
Depends:
  bats, bats-support, bats-assert,
  libwasmedge-dev,
  build-essential,
  rustc,
  rust-llvm,
  cargo,
  libstd-rust-dev-wasm32,

Tests: embed-cxx
Depends:
  bats, bats-support, bats-assert,
  libwasmedge-dev,
  build-essential,
  clang,
  lld,
  libclang-rt-dev-wasm32,
  wasi-libc,
  libc++-dev-wasm32,

=== debian/watch ===
Version: 5

Template: Github
Owner: WasmEdge
Project: WasmEdge
Repacksuffix: +dfsg
Dversion-mangle: auto
Uversion-Mangle: s/-(alpha|beta|rc)\.?/~$1/
